#ifndef sys_select_h
#define sys_select_h

#ifndef   sys_types_h
#include "sys_types.h"
#endif

#if defined(Darwin) || defined(Linux)
#define HAS_fd_mask 1
#endif

#if !defined(HAS_fd_mask)
#if defined(SUN4) || defined(OSF1) || defined(FREEBSD)
typedef long	fd_mask;
#define HAS_fd_mask 0
#endif
#endif

#ifndef NFDBITS
#define NFDBITS	(sizeof(fd_mask) * NBBY)	/* bits per mask */
#endif
#ifndef FD_SET
#define FD_SET(n, p)	((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#endif
#ifndef FD_CLR
#define FD_CLR(n, p)	((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#endif
#ifndef FD_ISSET
#define FD_ISSET(n, p)	((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#endif
#ifndef FD_ZERO
#define FD_ZERO(p)	BZero((p), sizeof(*(p)))
#endif

#endif
