
#include "V.h"
/*
* Debug wrapper for the putenv() library routine.   Warning:   On  most  Unix
* systems,  there  is  a potential memory leak here.  The string passed to us
* must not be on the stack, or it will be garbaged when the  caller  returns.
* But  there is no mechanism for remembering how old environment strings were
* allocated. Thus, if you overwrite an environment variable with a new value,
* the  space occupied by the old value will not be reclaimed.  It's not clear
* how a library routine could solve this, and it's not easy for the caller to
* solve it, either.
*/
int d_putenv(string)
	char *string;
{	int   v=0;

	V6 "putenv(%08X)=%08X [Err %d=%s=%s]",string, v, Errinfo D;
	v = (int)putenv(string);
	if (v)
		V5 "Putenv(\"%s\") failed, returned %d.",string,v D;
	return(v);
}
