
#include "V_s_lc.h"
	global int dbn_read = 0;	/* Read counter */
extern Flag Vchknull;		/* If true, check for nulls */
extern int  Vmaxnull;		/* If true, max length string of nulls */
extern int  Vlennull;		/* Longest string of nulls so far */

#if defined(USE_syscall) && defined(SYS_read)
read(f,b,n) char *b; {return syscall(SYS_read,f,b,n);}
#endif

d_read(f,b,n)
	int   f;
	char *b;
	Sizt  n;
{	Sizt  v;
	int   e=errno, i;
	File *fp = d_openfile(f);
	++dbn_read;

#if defined(USE_syscall) && defined(SYS_read)

	v = syscall(SYS_read,f,b,n);
	if (v<0) e = errno;
	V6s "syscall(SYS_read,%d,%08lX,%d)=%d [Err %d=%s=%s]",f,b,n,v,Errinfo D;
#else

	v = read(f,b,n);
	if (v<0) e = errno;
	V5s "read(%d,%08lX,%d)=%d (%d reads) [Err %d=%s=%s]",f,b,n,v,(fp?fp->reads:0),Errinfo D;
#endif
	if (v > 0) {
		H7s(b,v,"read");
		if (fp) fp->addr += v;	/* Keep track of the offset */
	}
	if (Vchknull)
		if (i = Vcntnulls(b,v))
			V3 "### String of %d nulls >= Vmaxnull=%d read from file %d offset %lu."
				,i,Vmaxnull,f,(fp?fp->addr:0) D;
	errno = e;
	return v;
}
