#ifndef exit_h
#define exit_h
/*
* To solve the difficult problem of getting error codes propogated all
* the  way  up  to  main(),  the  following can be used by lower-level
* routines to post global notice of  a  fatal  error  condition.   The
* exitstat  variable is initially zero, which is a "success" exit, but
* assigning it a nonzero value will (eventually) result  in  an  error
* exit.
*/

#ifndef ExitStat
#define ExitStat(x) {exitstat=(x);exitfile=__FILE__;exitline=__LINE__;Pexitstat;}
#define Pexitstat V3 m_exitstat,exitstat,exitfile,exitline D
#endif

extern  char m_exitstat[];
extern  int    exitstat;
extern  char*  exitfile;    /* File name for ExitStat() */
extern  int    exitline;    /* Line number for ExitStat() */

#endif
