
#include "V.h"
/*
* Set an alarm for n seconds in the future.  Note that n=0 turns off alarms.
*/
d_alarm(n)
{	int   v;

	if (n > 0) {
		P4 "%s\tAlarm set at n=%d + Vlvl=%d seconds.",Vtime(),n,Vlvl D;
		n += Vlvl;
	} else {
		P4 "%s\tAlarm off.",Vtime() D;
	}

	errno = 0;
	v = alarm(n);
	V6 "alarm(%d)=%d [Err %d=%s=%s]",n,v,Errinfo D;
	return v;
}
